﻿
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using WPF_Window.Properties;

namespace WPF_Window
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        NotifyIcon notifyIcon = new NotifyIcon();

        public MainWindow()
        {
            System.Windows.Application.Current.ShutdownMode = ShutdownMode.OnExplicitShutdown;
            InitializeComponent();
            this.ShowInTaskbar = false;
            this.Loaded += new RoutedEventHandler(Window_Loaded);
            SystemTrayIconSetup();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var desktopWorkingArea = System.Windows.SystemParameters.WorkArea;
            this.Left = desktopWorkingArea.Right - this.Width;
            this.Top = desktopWorkingArea.Bottom - this.Height;
        }

        private void setDefaultDSR_Type(object obj, RoutedEventArgs args)
        {
            //var defaultSetting = Excel.IsChecked.Value ? "Excel" : TextEditor.IsChecked.Value ? "TextEditor" : "YetToSelect";

            //if (defaultSetting.ToLower().Equals("yettoselect"))
            //    System.Windows.MessageBox.Show("Please Choose 'DSR Type'->Hit 'Set Default' button");
            //else
            //{
            //    Settings.Default["DsrType"] = defaultSetting;
            //    Settings.Default.Save();
            //}

            //var defaultSettingTimeSlot = TimeSlot_18.IsChecked.Value ? "18:00" : TimeSlot_19.IsChecked.Value ? "19:30" : "YetToSelect";

            //if (defaultSettingTimeSlot.ToLower().Equals("yettoselect"))
            //    System.Windows.MessageBox.Show("Please Choose 'Time Slot'->Hit 'Set Default' button");
            //else
            //{
            //    Settings.Default["TimeSlot"] = defaultSettingTimeSlot;
            //    Settings.Default.Save();
            //}

            System.Windows.MessageBox.Show("Default value has been choosen. Click 'Submit'!");

        }

        private void submitButtonInvoked(object obj, RoutedEventArgs args)
        {
            Settings.Default.Save();
            TurnOffSystemTrayIconVisibility();
            this.Close();

            WPF_Window.StartWindow startWindowObj = new StartWindow(triggerMethodChooseNextWindowBasedOnDefault: false);
            startWindowObj.ChooseNextWindowBasedOnDefaultValue();
        }

        protected override void OnStateChanged(EventArgs e)
        {
            base.OnStateChanged(e);

            //if Window State is minimized, show ballon tip
            if (this.WindowState == WindowState.Minimized)
                ShowBallonTipInSystemTray();
        }

        #region SystemTray

        public void SystemTrayIconSetup()
        {
            //notify icon    
      
          //  notifyIcon.Icon = new System.Drawing.Icon("..\\Images\\48Px.ico");

            notifyIcon.Visible = true;
            notifyIcon.DoubleClick += new System.EventHandler(this.NotifyIcon_DoubleClick);
            notifyIcon.BalloonTipClicked += new System.EventHandler(this.NotifyIcon_DoubleClick);
            notifyIcon.MouseClick += new System.Windows.Forms.MouseEventHandler(this.NotifyIcon_MouseClick);
        }

        public void NotifyIcon_DoubleClick(object Sender, EventArgs e)
        {
            // Show the form when the user double clicks on the notify icon.               
            if (this.WindowState == WindowState.Minimized)
                this.WindowState = WindowState.Normal;

            // Activate the form.
            this.Activate();
        }

        public void NotifyIcon_MouseClick(object Sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (this.WindowState == WindowState.Minimized)
                this.WindowState = WindowState.Normal;

            // Activate the form.
            this.Activate();
        }

        public void TurnOffSystemTrayIconVisibility()
        {
            notifyIcon.Visible = false;
            notifyIcon.Dispose();
        }

        public void ShowBallonTipInSystemTray()
        {
            notifyIcon.ShowBalloonTip(5000, "DSR Tool-Default Settings", "DSR-Default Settings Window is minimized", ToolTipIcon.Info);
        }

        #endregion SystemTray
    }
}
