﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using WPF_Window.Properties;

namespace WPF_Window
{
    /// <summary>
    /// Interaction logic for StartWindow.xaml
    /// </summary>
    public partial class StartWindow : Window
    {

        public StartWindow()
        {
            InitializeComponent();
        }
        public StartWindow(bool triggerMethodChooseNextWindowBasedOnDefault = true)
        {
            System.Windows.MessageBox.Show("Message Box.");
           // ShowMainWindow();
            if (triggerMethodChooseNextWindowBasedOnDefault)
                ChooseNextWindowBasedOnDefaultValue();
        }

        public void ChooseNextWindowBasedOnDefaultValue()
        {
            if (string.IsNullOrEmpty(Properties.Settings.Default.DsrType) || string.IsNullOrEmpty(Properties.Settings.Default.TimeSlot))
            {
                ShowMainWindow();
            }

            else if (Settings.Default["DsrType"].ToString().ToLower() == "excel")
            {
                ShowLoadExcelWindow();
            }

            else if (Settings.Default["DsrType"].ToString().ToLower() == "texteditor")
            {
                ShowTextEditorWindow();
            }
        }

        public void ShowMainWindow()
        {
            WPF_Window.MainWindow obj = new MainWindow();
            obj.Show();

        }

        public void ShowLoadExcelWindow()
        {
            ExcelWindow obj = new ExcelWindow();
            obj.Show();
        }

        public void ShowTextEditorWindow()
        {
            //  WpfApplication1.Windows.TextEditor.TextEditor obj = new TextEditor.TextEditor();
            // obj.Show();
        }

        public void ExitCurrentWindow()
        {
            this.Close();
        }
    }
}
